<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Authentication StructType
 * @subpackage Structs
 */
class Authentication extends AbstractStructBase
{
    /**
     * The appKey
     * @var string
     */
    public $appKey;
    /**
     * The appSecret
     * @var string
     */
    public $appSecret;
    /**
     * Constructor method for Authentication
     * @uses Authentication::setAppKey()
     * @uses Authentication::setAppSecret()
     * @param string $appKey
     * @param string $appSecret
     */
    public function __construct($appKey = null, $appSecret = null)
    {
        $this
            ->setAppKey($appKey)
            ->setAppSecret($appSecret);
    }
    /**
     * Get appKey value
     * @return string|null
     */
    public function getAppKey()
    {
        return $this->appKey;
    }
    /**
     * Set appKey value
     * @param string $appKey
     * @return \StructType\Authentication
     */
    public function setAppKey($appKey = null)
    {
        // validation for constraint: string
        if (!is_null($appKey) && !is_string($appKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($appKey)), __LINE__);
        }
        $this->appKey = $appKey;
        return $this;
    }
    /**
     * Get appSecret value
     * @return string|null
     */
    public function getAppSecret()
    {
        return $this->appSecret;
    }
    /**
     * Set appSecret value
     * @param string $appSecret
     * @return \StructType\Authentication
     */
    public function setAppSecret($appSecret = null)
    {
        // validation for constraint: string
        if (!is_null($appSecret) && !is_string($appSecret)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($appSecret)), __LINE__);
        }
        $this->appSecret = $appSecret;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Authentication
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
